#include "oddlike.h"
#include <cassert>
#include <cstdio>
#include <string>
#include <vector>
#include <iostream>

using namespace std;

namespace gaagknngisaqbpspikwc {
    vector <int> g;
    vector <vector<int>> f;
    int Q;
    int n, male, D;

    void solve(){
        assert(scanf("%d", &n) == 1);
        assert(scanf("%d", &male) == 1);
        assert(scanf("%d", &D) == 1);

        g.resize(n);
        for (int i = 0; i < n; i++) {
            assert(scanf("%d", &g[i]) == 1);
        }

        f.resize(n);
        for(int i = 0; i < n; ++i){
            f[i].resize(n);
            for(int j = 0; j < n; ++j){
                assert(scanf("%d", &f[i][j]) == 1);
            }
        }

        Q = 0;

        vector<int> T = love(n, male, D);

        printf("%d\n", Q);
        printf("%d\n", (int)T.size());
        for(int i=0;i<T.size();i++) {
            printf("%d", T[i]);
            if(i < T.size() - 1) {
                printf(" ");
            }
        }
        printf("\n");
    }
}

int count_like(int a, std::vector<int> v){
    using namespace gaagknngisaqbpspikwc;

    ++Q; assert(Q <= n * n);
    assert(0 <= a && a < n);

    vector<bool> vis(n, 0);
    for(int i : v){
        assert(0 <= i && i < n);
        assert(!vis[i]);
        vis[i] = true;
    }

    int ct = 0;
    for(int i = 0; i < (int)v.size(); ++i){
        ct += f[a][v[i]];
    }
    return ct;
}

int main() {
    int t;
    assert(scanf("%d", &t) == 1);

    while (t--){
        gaagknngisaqbpspikwc::solve();
    }

    return 0;
}
